set linesize 32000
set pagesize 1000
set head on
set echo on
set termout on
set trimspool on

spool oraclejoins5.log

set define off

drop table zyda;
drop table zyes;
drop table zypo;
drop table zd00;
drop table zdmx;

create table zyda (
datdeb VARCHAR2(20),
datfin VARCHAR2(20),
motabs VARCHAR2(20),
nudoss NUMBER,
numtra VARCHAR2(20));

create table zyes (
codsor VARCHAR2(20),
datent VARCHAR2(20),
datsor VARCHAR2(20),
nudoss NUMBER);

create table zypo (
dateff date,
datxxx date,
nudoss NUMBER,
sitcod VARCHAR2(20));

create table zd00 (
cdcode VARCHAR2(20),
cdregl VARCHAR2(20),
cdstco VARCHAR2(20),
nudoss NUMBER);

create table zdmx (
codsor VARCHAR2(20),
nudoss NUMBER,
temabs VARCHAR2(20),
codabs VARCHAR2(20),
codpos VARCHAR2(20));

-- oracle outer joins

SELECT h.cdcode, d.cdcode, f.cdcode
FROM zyda a,
zyes b,
zypo c,
zd00 d,
zdmx e,
zd00 f,
zdmx g,
zd00 h,
zdmx i
WHERE a.nudoss(+) = b.nudoss
AND c.nudoss = b.nudoss
AND b.nudoss = 159169
and d.nudoss(+) = e.nudoss
and f.nudoss(+) = g.nudoss
and h.nudoss(+) = i.nudoss
AND d.cdstco(+) = 'HID'
AND d.cdregl(+) = 'FR6'
AND f.cdstco(+) = 'HID'
AND f.cdregl(+) = 'FR6'
AND h.cdstco(+) = 'HID'
AND h.cdregl(+) = 'FR6'
and e.codsor(+) = b.codsor
AND e.codsor(+) = ' '
and g.codpos(+) = c.sitcod
AND i.codabs(+) = a.motabs
AND i.temabs(+) = CASE WHEN a.numtra = '1' THEN 'P' WHEN a.numtra = '2' THEN 'D' WHEN a.numtra = '3' OR a.numtra = '0' THEN 'S' ELSE a.numtra END
AND to_date('01/10/1987','DD/MM/YYYY') BETWEEN c.dateff AND (c.datxxx - 1)
AND to_date('01/10/1987','DD/MM/YYYY') BETWEEN a.datdeb(+) AND a.datfin(+)
AND to_date('01/10/1987','DD/MM/YYYY') BETWEEN b.datent AND b.datsor;

select * from table(dbms_xplan.display_cursor(null,null,'ALL'));

-- ansi joins

SELECT h.cdcode, d.cdcode, f.cdcode
  FROM zyes b
       LEFT JOIN zyda a ON (a.nudoss = b.nudoss AND 
                            TO_DATE ('01/10/1987', 'DD/MM/YYYY') BETWEEN a.datdeb AND a.datfin)
       JOIN zypo c ON (b.nudoss = c.nudoss)
       LEFT JOIN zdmx e ON (e.codsor = b.codsor AND e.codsor = ' ')
       LEFT JOIN zd00 d ON (d.nudoss = e.nudoss AND d.cdstco = 'HID' AND d.cdregl = 'FR6')
       LEFT JOIN zdmx g ON (g.codpos = c.sitcod)
       LEFT JOIN zd00 f ON (f.nudoss = g.nudoss AND f.cdstco = 'HID' AND f.cdregl = 'FR6')
       LEFT JOIN zdmx i ON (i.codabs = a.motabs
            AND i.temabs = CASE 
                WHEN a.numtra = '1' THEN 'P' 
                WHEN a.numtra = '2' THEN 'D' 
                WHEN a.numtra = '3' OR a.numtra = '0' THEN 'S' 
                ELSE a.numtra END)
       LEFT JOIN zd00 h ON (h.nudoss = i.nudoss AND h.cdstco = 'HID' AND h.cdregl = 'FR6')
 WHERE     b.nudoss = 159169
       AND TO_DATE ('01/10/1987', 'DD/MM/YYYY') BETWEEN c.dateff AND (c.datxxx - 1)
       AND TO_DATE ('01/10/1987', 'DD/MM/YYYY') BETWEEN b.datent AND b.datsor;
       
select * from table(dbms_xplan.display_cursor(null,null,'ALL'));


spool off

